  
  //  === MazeMate ===
  
  
  //import Video-Library
  import processing.video.*;
  Capture cam;
  
  //import Serial-Library
  import processing.serial.*;
  
  //import Arduino für Processing
  import cc.arduino.*;
  Arduino arduino;
  
  //Auflösung der Kamera und Größe des Rasters
  int myWidth = 640;
  int myHeight = 480;
  int mazeSize = 10;
  int gridWidth = myWidth / mazeSize;
  int gridHeight = myHeight / mazeSize;
  
  //Arrays für Farbe aller Pixel und aller Rasterfelder
  color[][] colorsPixels = new color[myWidth][myHeight];
  color[][] colorsGrid = new color[mazeSize + 2][mazeSize + 2];
  
  //Array für offene Wege für alle Rasterfelder
  int[][] ways = new int[mazeSize + 2][mazeSize + 2];
  
  //Array für Punkte der Lösung und Parameter
  int[][] solution = new int[mazeSize + 2][mazeSize + 2];
  int k = 1;
  
  //Arrays für Kreuzungen (Punkte mit mehr als einem offenen Weg
  int[] xCrossings;
  int[] yCrossings;
  
  //Arrays für Position der Lösungspunkte
  int[] xPos;
  int[] yPos;
  
  //Anzahl der Kreuzungen im Labyrinth
  int crossingsCount = 0;
  
  //Anzahl der Punkte in der Lösung
  int solutionCount = 0;
  
  //Anzahl der Wiederholungen
  int count = 0;
  
  //Farbwerte für schwarz und weiß
  color white = -1;
  color black = -16777216;
  
  //Umschalten zwischen Aufnahme und Lösen
  boolean record = true;
  boolean solve = true;
  boolean screen = false;
  
  //Start- und Endpunkt des Labyrinths
  int xStart = 1;
  int yStart = 1;
  int xEnd = 10;
  int yEnd = 10;
  int x = xStart;
  int y = yStart;
  ;
void setup() {

  surface.setSize (myWidth, myHeight);
  
  //Aufnahme durch Webcam
  cam = new Capture (this, myWidth, myHeight);
  cam.start();
  
  //Einrichtung des Arduino
  arduino = new Arduino(this, Arduino.list()[0], 57600);
  arduino.pinMode(dirPinX, Arduino.OUTPUT);
  arduino.pinMode(stepPinX, Arduino.OUTPUT);
  arduino.pinMode(dirPinX, Arduino.OUTPUT);
  arduino.pinMode(stepPinX, Arduino.OUTPUT);
}

void keyReleased() {
  if (key == '.') {
    screen = !screen;
    record = true;
  }
}

void draw() {
  
  //Steuerung der einzelnen Funktionen
  if (record == true) {
    record();
  } else if (solve == true) {
    
    //beendet das Programm, wenn Zielpunkt erreicht ist und zeichnet den Weg ein
    if (x == xEnd && y == yEnd) {
      println("solved.");
      println("needed runs: " + count);
      solve = false;
    }
    
    if (solve == true) solve();
    
  } else {
    show();
    move();
  }
}