  
  //steuert den Arduino
  //bewegt den Elektromagneten
  //visualisiert den Lösungsweg auf dem Spielfeld
  
  //Pinbelegung des Arduino
  int dirPinX = 2;
  int stepPinX = 3;
  int dirPinY = 6;
  int stepPinY = 7;
  int dirPinEM = 4;
  int stepPinEM = 5;
  int pinEM = 8;
  
  //Distanz und Richtung zwischen 2 Punkten des Lösungswegs
  int distX;
  int dirX = 0;
  int distY;
  int dirY = 0;
  
  //Strecke, um die der Magnet gehoben wird
  int magnetHeight = 100;
  
  //Richtungen des Magneten
  int down = 1;
  int up = 0;
  
  //Position des Ablageorts für die weißen bzw. die roten Scheiben
  int xPosDump;
  int yPosDump;
  int xPosRed;
  int yPosRed;
  
  //Richtung zwischen den beiden Stapeln
  int dirStack = 0;
  
void moveX(float dist, int dir) {
  
  arduino.digitalWrite(dirPinX, dir);
  float pulses = dist;
  
  for ( int i = 0; i < pulses; i++) {
    arduino.digitalWrite(stepPinX, Arduino.HIGH);
    delay(1);
    arduino.digitalWrite(stepPinX, Arduino.LOW);
    delay(1);
  }
}

void moveY(float dist, int dir) {
  
  arduino.digitalWrite(dirPinY, dir);
  float pulses = dist;
  
  for ( int i = 0; i < pulses; i++) {
    arduino.digitalWrite(stepPinY, Arduino.HIGH);
    delay(1);
    arduino.digitalWrite(stepPinY, Arduino.LOW);
    delay(1);
  }
}

void magnet(int dir) {
  
  arduino.digitalWrite(dirPinEM, dir);
  
  for ( int i = 0; i < magnetHeight; i++) {
    arduino.digitalWrite(stepPinEM, Arduino.HIGH);
    delay(1);
    arduino.digitalWrite(stepPinEM, Arduino.LOW);
    delay(1);
  }
}

void move() {
  
//  moveX(Ausgangsposition bis xPos[0]);
//  moveY(Ausgangsposition bis yPos[0]);
  
  for(int i = 1; i < solutionCount - 2; i++) {
    
    magnet(down);
    arduino.digitalWrite(pinEM, Arduino.HIGH);
    magnet(up);
    
    distX = xPosDump - xPos[i];
    distY = yPosDump - yPos[i];
    if (distX < 0) dirX = 1;
    if (distY < 0) dirY = 1;
    
    moveX(distX, dirX);
    moveY(distY, dirY);
    
    arduino.digitalWrite(pinEM, Arduino.LOW);
    moveX(xPosDump - xPosRed, dirStack);
    moveY(yPosDump - yPosRed, dirStack);
    magnet(down);
    arduino.digitalWrite(pinEM, Arduino.HIGH);
    magnet(up);
    
    distX = xPosRed - xPos[i];
    distY = yPosRed - yPos[i];
    if (distX < 0) dirX = 1;
    if (distY < 0) dirY = 1;
    
    moveX(distX, dirX);
    moveY(distY, dirY);
    
    magnet(down);
    arduino.digitalWrite(pinEM, Arduino.LOW);
    magnet(up);
    
    distX = xPos[i] - xPos[i + 1];
    distY = yPos[i] - yPos[i + 1];
    if (distX < 0) dirX = 1;
    if (distY < 0) dirY = 1;
    
    moveX(distX, dirX);
    moveY(distY, dirY);
    
  }
  
  magnet(down);
  arduino.digitalWrite(pinEM, Arduino.HIGH);
  magnet(up);
  
  distX = xPosDump - xPos[solutionCount - 1];
  distY = yPosDump - yPos[solutionCount - 1];
  if (distX < 0) dirX = 1;
  if (distY < 0) dirY = 1;
  
  moveX(distX, dirX);
  moveY(distY, dirY);
  
  arduino.digitalWrite(pinEM, Arduino.LOW);
  moveX(xPosDump - xPosRed, dirStack);
  moveY(yPosDump - yPosRed, dirStack);
  magnet(down);
  arduino.digitalWrite(pinEM, Arduino.HIGH);
  magnet(up);
  
  distX = xPosRed - xPos[solutionCount - 1];
  distY = yPosRed - yPos[solutionCount - 1];
  if (distX < 0) dirX = 1;
  if (distY < 0) dirY = 1;
  
  moveX(distX, dirX);
  moveY(distY, dirY);
  
  magnet(down);
  arduino.digitalWrite(pinEM, Arduino.LOW);
  magnet(up);
  
//  moveX(bis Ausgangsposition);
//  moveY(bis Ausgangsposition);

  println("done.");
  noLoop();
  
}